(define (inc i) (+ i 1))
(define (square i) (* i i))
(define (cube x) (* x x x))

; define sum of cubes directly

(define (sum-cubes a b)
  (if (> a b)
      0
      (+ (cube a) (sum-cubes (+ a 1) b))))

; define pi-sum directly (actually, this is pi/8)

(define (pi-sum a b)
  (if (> a b)
      0
      (+ (/ 1.0 (* a (+ a 2))) (pi-sum (+ a 4) b))))

; define general purpose summation procedure
; term - calculate the term in the sum from a single arg x
; a - lower summation limit
; next - calculate next index value given current index value
; b - upper summation limit

(define (sum term a next b)
  (if (> a b)
      0
      (+ (term a)
         (sum term (next a) next b))))

; define pi-sum without explicit auxiliary functions

(define (pi-sum2 a b)
  (sum 
   (lambda (i) (/ 1.0 (* i (+ i 2))))
   a
   (lambda (i) (+ i 4))
   b))


(sum-cubes 1 10)   ; => 3025
(* 8 (pi-sum 1 10000))   ; = pi
(* 8 (pi-sum2 1 10000))   ; = pi
